<%--
 * Component: dotcom
 *
 * Description:
 *    Draws full site configuration diagram
 *
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@
	page import="imagemed.imsession.*, imagemed.util.*, imagemed.dotcom.*, java.util.*, java.io.*"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%

	IMSession is = new IMSession(request, response, out);
	is.bRegNotNeeded = false;
	is.bCheckHttpsAndRedirect = false;

%><HTML><HEAD><TITLE>Full Site Configuration</TITLE>

<SCRIPT language="JavaScript">

	function popupwin_(device) {
		window.open('/dotcom/twopigraph.jsp?cDevice=' + device, 'popup_' +device,'width=700, height=700');
	}

</SCRIPT>

</HEAD><BODY><PRE>

<%
	//Hashtable devIfaces = new Hashtable();
	String selfId = DotcomConfig.selfId();
	Map<String, Device> devices = DotcomConfig.getConfig().getDevices();
	
	FileWriter fileWriter = new FileWriter(IMEnvBase.getEnv("TMP") + "/neatograph.dot");
	fileWriter.write("graph tdotcom {\n");
	fileWriter.write("spines = true\n");
	fileWriter.write("overlap = scale\n");

	for (Iterator<Device> e = devices.values().iterator() ; e.hasNext() ;) {
		Device d = e.next();
		String dDev = d.getId();
		String dDevice = dDev.replaceAll("-","_dash_");

		if (d instanceof DotcomDevice) {
			DotcomDevice dd = (DotcomDevice) d;
					String[] childr = dd.getChildren();
					for (int i = 0; i < childr.length; i++){
						String child = childr[i];
						String children = child.replaceAll("-","_dash_");
						fileWriter.write(dDevice + " -- " + children + ";\n");
					}
					
					Set<DeviceInterface> interfaces = dd.getInterfaces();
					for (Iterator<DeviceInterface> f = interfaces.iterator() ; f.hasNext() ; ) {
						DeviceInterface g = f.next();
						String gDev = g.getId();
						String gDevice = gDev.replaceAll("-","_dash_");
						fileWriter.write(dDevice + " -- " + gDevice + " [color = grey]\n");
					}
					}
	}

	for (Iterator<Device> e = devices.values().iterator() ; e.hasNext() ;) {
		Device dev = e.next();
		String dId = dev.getId();
		String devId = dId.replaceAll("-","_dash_");
		//Properties 	prpIfaces = (Properties) devIfaces.get(devId);
		String settings = (dev instanceof DotcomDevice) ? " [shape = record, URL = \"" + devId + "\", color = black, label = \"<f0> " : " [color = grey, label = \" ";
		String filledAttr = (devId.equals(selfId)) ? " \", style = filled, fillcolor = lightgrey]\n" : " \"]\n";
		fileWriter.write (devId + settings + devId + filledAttr);
	}

	fileWriter.write("}\n");
	fileWriter.close();

	String cmd[] = new String[6];
	cmd[0] = "neato";
	cmd[1] = "-T";
	cmd[2] = "png";
	cmd[3] = "-o";
	cmd[4] = IMEnvBase.getEnv("MAIN_DATA") + "/neatograph.png";
	cmd[5] = IMEnvBase.getEnv("TMP") + "/neatograph.dot";

	Helper.runCommand(cmd, null);

	String cmd2[] = new String[6];
	cmd2[0] = "neato";
	cmd2[1] = "-T";
	cmd2[2] = "cmap";
	cmd2[3] = "-o";
	cmd2[4] = IMEnvBase.getEnv("MAIN_DATA") + "/neatograph.cmap";
	cmd2[5] = IMEnvBase.getEnv("TMP") + "/neatograph.dot";

	Helper.runCommand(cmd2, null);
	
%>
</PRE>

<IMG SRC="/main/data/neatograph.png" border=none usemap="#mapdotcom">
<MAP name="mapdotcom">
<%

	BufferedReader br = new BufferedReader(new FileReader(IMEnvBase.getEnv("MAIN_DATA") + "/neatograph.cmap"));
	String cmapLine = null;
	while (null != (cmapLine = br.readLine())) {
		int posHref = cmapLine.indexOf("href");
		int p1 = cmapLine.indexOf("\"", posHref);
		int p2 = cmapLine.indexOf("\"", p1+1);
		String deviceId = cmapLine.substring(p1+1, p2);
		out.print(cmapLine.substring(0, p1+1));
		out.print("JavaScript:popupwin_('" + deviceId + "');");
		out.println(cmapLine.substring(p2));
	}
	br.close();
%>
</MAP>

</BODY></HTML>
				

					
