<%--
 * Component: dotcom
 *
 * Description:
 *   Runs a query on local neighbour (parent and children) dotcom servers and returns the merged results as URLEncoded lines.
 *
 * TODO:
 *    Current implementation is used for ArchivesResult only (hard coded).
 *    Either a general solution should be implemented or separate jsp files should be used for separate functions
 * 
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%><%@
	page import="imagemed.tables.*, imagemed.imtables.*, imagemed.imsession.*, imagemed.util.Helper,
			java.util.Properties, imagemed.jsputil.DotcomToolbox"

%><%
	IMSession is = new IMSession( request, response, out );
	is.createIMRequest( false );
	String peerId = null;

	try {
		Properties prpDevice = DotcomToolbox.checkClient( is, null, false );
		peerId = prpDevice.getProperty( "ID" );
	}
	catch ( Throwable th ) {
		// Return as if no record found
		IMEnv.debugLog( "queryDotcom.jsp EXCEPTION when checking client " + th.toString() );
		out.println( "&NUMOFREC=0&ISCOMPLETE=true" );
		return;
	}

	IMEnv.debugLog( "queryDotcom.jsp client is " + peerId );

	String afmMode = request.getParameter( "afmMode" );
	
	Result result = null;

	TableDescriptor tdesc = new TableDescriptor( null );
	TableParams tp = new TableParams( is.imRequest );
	if ( afmMode != null ) {
		try {
			ArchivesFieldManager.MODE mode = ArchivesFieldManager.MODE.valueOf( afmMode );
			ArchivesFieldManager fm = new ArchivesFieldManager( mode, ArchivesFieldManager.ISSUER.REMOTE );
			tdesc.setTableParams( tp );
			tdesc.setFieldManager( fm );
			result = new ArchivesResult( tdesc, peerId ); 
			( ( ArchivesResult ) result ).writeFor( out );
		}
		catch ( IllegalArgumentException iaEx ) {
			Helper.ERRORLOG( "queryDotcom", "Invalid Archive Field Manager mode: " + afmMode );
		}
	}

	if ( "true".equals( request.getParameter( "cDebug" ) ))
		out.println( "DEBUG:\n" + result.getDebug() );

	
	// No more new lines
	if ( true )
		return;
%>
